<?php
/*
Plugin Name: Youtube Video Feed Shortcode
Plugin URI: http://www.nsauditor.com/wordpress/youtube-video-feed-shortcode/
Description: The plugin allows to embed Youtube video feeds in your post/page content using shortcode [YouTubeVideoFeed] 
Author: Varuzhan Kankanyan
Author URI: http://www.nsauditor.com
Version: 1.0.1
License: GNU General Public License version 2.0 or above
License URI: http://www.gnu.org/licenses/gpl-2.0.html
*/

require_once('nsYoutubeVideoFeedParser.class.php');

function displayYoutubeFeedShortcodeVideos($widget_title,$channel,$maxfeeds,$orderby,$showrelated,$showtitle,$showdesc,$maxsentences,$maxtextsz,$width='300',$height='220')
{
	$content = '';	
	$nsYoutubeFeedParser = new nsYoutubeVideoFeedParser($channel);
	$count = $maxfeeds;
	if($showrelated)
	{
		$query='';
		$pagetitle = get_the_title();
	
		$query=strtolower ($pagetitle);			
		$query=str_replace(' ','+',$query);	
	
		$count = $nsYoutubeFeedParser->parseYoutubeFeed($orderby,$maxfeeds,$query);
		if($count==0)
		{
			$id = get_the_id();
			$terms = get_the_terms($id,'category');	
			$cats = array();
			if(is_array($terms)){
				foreach($terms as $term){
					$cats[]=$term->name;
				}
			}
			if(count($cats))
			{
				$query = implode("+", $cats);
				$query=str_replace(' ','+',$query);			
			}
			else
			{
				$terms = get_the_terms($id,'post_tag');	
				$tags = array();
				if(is_array($terms)){
					foreach($terms as $term){
						$tags[]=$term->name;
					}	
				}
				$query = implode("+", $tags);
				$query=str_replace(' ','+',$query);			
			}	
			
			$count = $nsYoutubeFeedParser->parseYoutubeFeed($orderby,$maxfeeds,$query);
			if($count==0){$count = $nsYoutubeFeedParser->parseYoutubeFeed($orderby,$maxfeeds);}
		}
	}
	else
	{
		$count = $nsYoutubeFeedParser->parseYoutubeFeed($orderby,$maxfeeds);
	}
	$nsYoutubeFeedNode = new nsYoutubeVideoFeedNode;
	
	if($count) {$content .= $widget_title;}
	if($count>$maxfeeds) $count=$maxfeeds;

	for($i = 0; $i < $count; $i++)
	{
		if($nsYoutubeFeedParser->getYFeedEntry($nsYoutubeFeedNode,$i,$maxsentences,$maxtextsz))
		{		
			$content .= "<div class='youtube-video-feed-shortcode'>";
			if($showtitle){$content .= "<div class='youtube-video-feed-shortcode-title'><a href='$nsYoutubeFeedNode->link' target='_blank'>$nsYoutubeFeedNode->title</a></div>";}
			$content .= "<div><center><iframe width=$width height=$height src='$nsYoutubeFeedNode->id' frameborder='0' allowfullscreen></iframe></center></div>";	
			if($showdesc){$content .= "<div class='youtube-video-feed-shortcode-desc'><p>$nsYoutubeFeedNode->description</p></div>";}
			$content .= "</div>";
		}
	}
	
	unset($nsYoutubeFeedParser);
	unset($nsYoutubeFeedNode);	
	return $content;
}

function handleShortcode($atts)
{	
	extract( shortcode_atts( array(
			  'title' => 'Popular Videos',
			  'channel' => '',
			  'maxfeeds' => '1',
			  'showtitle' => '0',				  
			  'orderby' => 'viewCount',
			  'showrelated' => '0',
			  'showdesc' => '0',
			  'maxsentences' => '1',
			  'maxtextsz' => '400',
			  'width' => '400',
			  'height' => '300',
		 ), $atts, 'YouTubeVideoFeed' ) );			 
	
	$widget_title = '<h3 class="youtube-video-feed-shortcode-headline">'.esc_attr($title).'</h3>';	
	
	if(is_singular())
		return displayYoutubeFeedShortcodeVideos($widget_title,esc_attr($channel),(int)esc_attr($maxfeeds),esc_attr($orderby),(bool)esc_attr($showrelated),(bool)esc_attr($showtitle),(bool)esc_attr($showdesc),(int)esc_attr($maxsentences),(int)esc_attr($maxtextsz),(int)esc_attr($width),(int)esc_attr($height));
	
	return	'';
}

function addYoutubeFeedShortcodeStylesheet() 
{
	wp_enqueue_style( 'youtubefeedshortcode-css', plugins_url('style.css', __FILE__) );
}

add_action( 'wp_enqueue_scripts', 'addYoutubeFeedShortcodeStylesheet' );
add_shortcode( 'YouTubeVideoFeed', 'handleShortcode' );

?>